-- [[ Variables. ]]

local PROMOTE_NAME = {}
local PROMOTE_COMPARE = {}
local PROMOTE_RANK = {}
local PROMOTE_CLASS = {}
local PROMOTE_INDEX = {}
local PROMOTE_NEWRANKINDEX = {}
local PromoteCounter = 0
local DEMOTE_NAME = {}
local DEMOTE_COMPARE = {}
local DEMOTE_RANK = {}
local DEMOTE_CLASS = {}
local DEMOTE_INDEX = {}
local DEMOTE_NEWRANKINDEX = {}
local DemoteCounter = 0
local TotalCounter = 0
local DNPs = {}
local DNPcount = 0
local ALTs = {}
local ALTcount = 0
local HEADER = "|cff69CCF0<SGP>|r: "
local version = "1.8"
local DDMSelected = {}

local FramesStuff = {
		["FRAMES"] = {},
		["BUTTONTEXTS"] = {},
		["CHECKBOXES"] = {},
		["EDITBOXES"] = {},
		["SPECIALS"] = {},
		["MESSAGEFRAMES"] = {},
		["LISTFRAME"] = {},
		["FILTERFRAME"] = {},
		["DROPDOWNS"] = {}
	}
	

-- [[ Functions. ]]

-- OnLogin
function OnLogin()
	GuildRoster()
	if type(SwynGuildPromoterConfig) ~= "table" then
		SwynGuildPromoterConfig = {}
	end
	if not SwynGuildPromoterConfig.version or not SwynGuildPromoterConfig.specialRanks or not SwynGuildPromoterConfig.selectedRanks then
		SwynGuildPromoterConfig = {}
		SwynGuildPromoterConfig.selectedRanks = {}
		SwynGuildPromoterConfig.specialRanks = {}
		SwynGuildPromoterConfig.version = version
		OnLogin()
	end
	if not SwynGuildPromoterConfig.version or SwynGuildPromoterConfig.version ~= version then
		SwynGuildPromoterConfig.version = version
	end
	if not SwynGuildPromoterConfig.dnpfilter then
		SwynGuildPromoterConfig.dnpfilter = false
	end
	if not SwynGuildPromoterConfig.altfilter then
		SwynGuildPromoterConfig.altfilter = false
	end
	if not SwynGuildPromoterConfig.promoteType then
		SwynGuildPromoterConfig.promoteType = 1
	end
	loadEverything()
	print(HEADER .. "SwynGuildPromoter loaded. Type /sgp for list of commands.")
end

-- Clear
function clearLists(msg)
	if msg == "All" or msg == "Promote" then
		ClearTable(PROMOTE_NAME)
		ClearTable(PROMOTE_COMPARE)
		ClearTable(PROMOTE_RANK)
		ClearTable(PROMOTE_CLASS)
		ClearTable(PROMOTE_INDEX)
		ClearTable(PROMOTE_NEWRANKINDEX)
		PromoteCounter = 0
		FramesStuff["MESSAGEFRAMES"]["SwynGuildPromote_ScrollingMessageFrame_Promote"]:Clear()
	end
	if msg == "All" or msg == "Demote" then
		ClearTable(DEMOTE_NAME)
		ClearTable(DEMOTE_COMPARE)
		ClearTable(DEMOTE_RANK)
		ClearTable(DEMOTE_CLASS)
		ClearTable(DEMOTE_INDEX)
		ClearTable(DEMOTE_NEWRANKINDEX)
		DemoteCounter = 0
		FramesStuff["MESSAGEFRAMES"]["SwynGuildPromote_ScrollingMessageFrame_Demote"]:Clear()
	end
	TotalCounter = 0
	if PromoteCounter+DemoteCounter == 0 then
		FramesStuff["LISTFRAME"]["SwynGuildPromote_ListFrame"]:Hide()
	end
end

-- Clear Table
function ClearTable(TABLE)
	for i,v in pairs(TABLE) do
		TABLE[i] = nil
	end
end

----===================================----
--[[ Snoops on guildies for their info ]]--
----===================================----
function cycleThroughMembers()
	GuildRoster()
	for i = 1,GetNumGuildMembers() do
		local weeklyXP, totalXP = GetGuildRosterContribution(i)
		local name, rank, rankIndex, level, class, zone, note,
		      officernote, online, status, classFileName,
			  achievementPoints, achievementRank, isMobile  = GetGuildRosterInfo(i)
		local compare = totalXP
		if DDMSelected["PromoteType"] == 2 then
			compare = level
		elseif DDMSelected["PromoteType"] == 3 then
			compare = achievementPoints
		end
		-- Ignore if they're the GM.
		if rankIndex >= 1 then
			-- Only check if we're allowed to mod this rank.
			if FramesStuff["CHECKBOXES"][rank]:GetChecked() then
				local newRankIndex = rankModifierCalculator(rankIndex+1, rank, compare)
				if newRankIndex ~= false then
					if newRankIndex < (rankIndex+1) and not string.find(officernote, "DNP") and not string.find(note, "ALT") and not string.find(officernote, "ALT") then
						table.insert(PROMOTE_NAME, name)
						table.insert(PROMOTE_COMPARE, compare)
						table.insert(PROMOTE_RANK, rank)
						table.insert(PROMOTE_CLASS, class)
						table.insert(PROMOTE_INDEX, i)
						table.insert(PROMOTE_NEWRANKINDEX, newRankIndex)
						PromoteCounter = PromoteCounter + 1
					elseif newRankIndex > (rankIndex+1) and not string.find(note, "ALT") and not string.find(officernote, "ALT") then
						table.insert(DEMOTE_NAME, name)
						table.insert(DEMOTE_COMPARE, compare)
						table.insert(DEMOTE_RANK, rank)
						table.insert(DEMOTE_CLASS, class)
						table.insert(DEMOTE_INDEX, i)
						table.insert(DEMOTE_NEWRANKINDEX, newRankIndex)
						DemoteCounter = DemoteCounter + 1
					end
				end
			end
		end
	end
end

----==========================----
--[[ Rank Modifier Calculator ]]--
----==========================----
-- Works out if we have to mod the rank, and in which direction.
-- Returns the index of the guild rank the player fits into.
function rankModifierCalculator(rankNum, rankName, compare)
	local numRanks = GuildControlGetNumRanks()
	
	-- Firstly, are we allowed to mod current rank?
	if FramesStuff["CHECKBOXES"][rankName]:GetChecked() then
		
		-- For each rank (except GM), work out the new rank index for each player.
		for i=2,numRanks do
			-- Check if player fits critera
			local currRank_Min
			if i == numRanks then
				currRank_Min = 0
			else
				currRank_Min = tonumber(FramesStuff["EDITBOXES"][GuildControlGetRankName(i)]:GetText())
			end
			if not currRank_Min or not FramesStuff["CHECKBOXES"][GuildControlGetRankName(i)]:GetChecked() then
				currRank_Min = -1
			end
			if compare >= currRank_Min and currRank_Min ~= -1 then
				local newRankIndex = i
				return newRankIndex
			end
		end
	end
	-- If we're here something went wrong.
	return false
end

----=====================================----
--[[ Promote Members that need Promoting ]]--
----=====================================----
function PromoteMembers()
	print(HEADER .. "Promoting all under-ranked members.")
	for i,v in pairs(PROMOTE_NAME) do
		if CanGuildPromote(v) then
			SetGuildMemberRank(PROMOTE_INDEX[i], PROMOTE_NEWRANKINDEX[i])
		else
			print(HEADER .. "|cffC41F3BFailed|r to promote " .. v .. ".")
		end
	end
	clearLists("Promote")
	ModifyButton("SwynGuildPromote_Button_OnlyPromote", "Only Promote: " .. PromoteCounter)
end

----===================================----
--[[ Demote Members that need Demoting ]]--
----===================================----
function DemoteMembers()
	print(HEADER .. "Demoting all over-ranked members.")
	for i,v in pairs(DEMOTE_NAME) do
		if CanGuildDemote(v) then
			SetGuildMemberRank(DEMOTE_INDEX[i], DEMOTE_NEWRANKINDEX[i])
		else
			print(HEADER .. "|cffC41F3BFailed|r to demote " .. v .. ".")
		end
	end
	clearLists("Demote")
	ModifyButton("SwynGuildPromote_Button_OnlyDemote", "Only Demote: " .. DemoteCounter)
end

----==============----
--[[ List Showing ]]--
----==============----
function showLists()
	for i,v in pairs(FramesStuff["MESSAGEFRAMES"]) do
		if v:GetName() == "SwynGuildPromote_ScrollingMessageFrame_Promote" then
			for k=1,PromoteCounter do
				v:AddMessage("|cff" .. getClassColor(PROMOTE_CLASS[k]) .. PROMOTE_NAME[k] .. "|r |cffEFE327" .. PROMOTE_RANK[k] .. "|r " .. PROMOTE_COMPARE[k])
			end
		elseif v:GetName() == "SwynGuildPromote_ScrollingMessageFrame_Demote" then
			for l=1,DemoteCounter do
				v:AddMessage("|cff" .. getClassColor(DEMOTE_CLASS[l]) .. DEMOTE_NAME[l] .. "|r |cffEFE327" .. DEMOTE_RANK[l] .. "|r " .. DEMOTE_COMPARE[l])
			end
		end
	end
	if PromoteCounter+DemoteCounter > 0 then
		FramesStuff["LISTFRAME"]["SwynGuildPromote_ListFrame"]:Show()
	end
end

----==============================----
--[[ Simple class colour function ]]--
----==============================----
function getClassColor(class)
	if class == "Death Knight" then
		return "C41F3B" 
	elseif class == "Druid" then
		return "FF7D0A"
	elseif class == "Hunter" then
		return "ABD473"
	elseif class == "Mage" then
		return "69CCF0"
	elseif class == "Paladin" then
		return "F58CBA"
	elseif class == "Priest" then
		return "FFFFFF"
	elseif class == "Rogue" then
		return "FFF569"
	elseif class == "Shaman" then
		return "0070DE"
	elseif class == "Warlock" then
		return "9482C9"
	elseif class == "Warrior" then
		return "C79C6E"
	else
		return "857C7C"
	end
end


----====================================================================----
--[[ Find and generate a list of guildies that need their rank changing ]]--
----====================================================================----
function Find()
	clearLists("All")
	cycleThroughMembers()
	ModifyButton("SwynGuildPromote_Button_OnlyPromote", "Only Promote: " .. PromoteCounter)
	ModifyButton("SwynGuildPromote_Button_OnlyDemote", "Only Demote: " .. DemoteCounter)
	
	showLists()
end

----=====================----
--[[ Slash Command Hooks ]]--
----=====================----
SLASH_SGP1, SLASH_SGP2, SLASH_SGP3 = '/sgp', 'sguildpromote', 'swynguildpromote';
function SlashCmdList.SGP(msg, editbox)
	if msg == 'show' then
		for i,v in pairs(FramesStuff["FRAMES"]) do
			v:Show()
		end
	elseif msg == 'hide' then
		for i,v in pairs(FramesStuff["FRAMES"]) do
			v:Hide()
		end
	else
		print(HEADER .. "Slash commands are:")
		print(HEADER .. "  |cffEFE327show|r - Shows the UI.")
		print(HEADER .. "  |cffEFE327hide|r - Hides the UI.")
	end
end

----===================----
--[[ Show Filter Frame ]]--
----===================----
function ShowFilters()
	ClearFilters()
	
	for i,v in pairs(FramesStuff["MESSAGEFRAMES"]) do
		if v:GetName() == "SwynGuildPromote_ScrollingMessageFrame_ALT" then
			ListALTs(v)
		elseif v:GetName() == "SwynGuildPromote_ScrollingMessageFrame_DNP" then
			ListDNPs(v)
		end
	end
	FramesStuff["FILTERFRAME"]["SwynGuildPromote_FilterFrame"]:Show()
end


----===============----
--[[ Clear Filters ]]--
----===============----
function ClearFilters()
	ClearTable(ALTs)
	ALTcounter = 0
	FramesStuff["MESSAGEFRAMES"]["SwynGuildPromote_ScrollingMessageFrame_ALT"]:Clear()
	ClearTable(DNPs)
	DNPcounter = 0
	FramesStuff["MESSAGEFRAMES"]["SwynGuildPromote_ScrollingMessageFrame_DNP"]:Clear()
end

----=====================----
--[[ Print Current ALT's ]]--
----=====================----
function ListALTs(smf)
	GuildRoster()
	ALTcounter = 0
	for i = 1,GetNumGuildMembers() do
		local weeklyXP, totalXP = GetGuildRosterContribution(i)
		local name, rank, rankIndex, level, class, zone, note,
		      officernote, online, status, classFileName,
			  achievementPoints, achievementRank, isMobile  = GetGuildRosterInfo(i)
		local compare = totalXP
		if DDMSelected["PromoteType"] == 2 then
			compare = level
		elseif DDMSelected["PromoteType"] == 3 then
			compare = achievementPoints
		end
		if string.find(note, "ALT") ~= nil or string.find(officernote, "ALT") then
			smf:AddMessage("|cff" .. getClassColor(class) .. name .. "|r |cffEFE327" .. rank .. "|r " .. compare)
			ALTcounter = ALTcounter+1
		end
	end
end

----=====================----
--[[ Print Current DNP's ]]--
----=====================----
function ListDNPs(smf)
	GuildRoster()
	DNPcounter = 0
	for i = 1,GetNumGuildMembers() do
		local weeklyXP, totalXP = GetGuildRosterContribution(i)
		local name, rank, rankIndex, level, class, zone, note,
		      officernote, online, status, classFileName,
			  achievementPoints, achievementRank, isMobile  = GetGuildRosterInfo(i)
		local compare = totalXP
		if DDMSelected["PromoteType"] == 2 then
			compare = level
		elseif DDMSelected["PromoteType"] == 3 then
			compare = achievementPoints
		end
		if string.find(officernote, "DNP") ~= nil then
			smf:AddMessage("|cff" .. getClassColor(class) .. name .. "|r |cffEFE327" .. rank .. "|r " .. compare)
			DNPcounter = DNPcounter+1
		end
	end
end

----===============----
--[[ Save Settings ]]--
----===============----
function SaveSettings()
	-- Clear Ranks and Special Ranks
	for i,v in pairs(SwynGuildPromoterConfig.selectedRanks) do
		SwynGuildPromoterConfig.selectedRanks[i] = nil
	end
	for i,v in pairs(SwynGuildPromoterConfig.specialRanks) do
		SwynGuildPromoterConfig.specialRanks[i] = nil
	end
	-- Rank Index
	local numRanks = GuildControlGetNumRanks()
	local ranksTable = {}
	for i=1,numRanks do
		ranksTable[GuildControlGetRankName(i)] = i
	end
	print(HEADER .. "Saving Settings.")
	-- Promote Type Saving
	SwynGuildPromoterConfig.promoteType = DDMSelected["PromoteType"]
	local promoteTypeText = ""
	if DDMSelected["PromoteType"] == 1 then
		promoteTypeText = "Total GuildXP"
	elseif DDMSelected["PromoteType"] == 2 then
		promoteTypeText = "Level"
	elseif DDMSelected["PromoteType"] == 3 then
		promoteTypeText = "Achievement Points"
	else
		promoteTypeText = "ERROR"
	end
	print(HEADER .. "  Promote Type: |cffF4DF2D" .. promoteTypeText .. "|r.")
	-- Rest
	for i,v in pairs(FramesStuff["CHECKBOXES"]) do
		local name = v:GetName()
		local index = ranksTable[name]
		local ticked = v:GetChecked()
		local limiter = tonumber(FramesStuff["EDITBOXES"][name]:GetText())
		local special = FramesStuff["SPECIALS"][name]:GetChecked()
		local specialText = " Special: |cff1FC42BYes|r."
		if not special then specialText = " Special: |cffC41F3BNo|r." end
		if not limiter then limiter = -1 end
		if not ticked then limiter = -1 end
			
		SwynGuildPromoterConfig.selectedRanks[name] = {name, index, limiter}
		if special then
			SwynGuildPromoterConfig.specialRanks[name] = {name, index}
		end
		if limiter >= 0 then
			print(HEADER .. "  Watching: |cffF4DF2D" .. name .. "|r. Requires: |cffF4DF2D" .. limiter .. "|r." .. specialText)
		else
			print(HEADER .. "  Ignoring: |cffF4DF2D" .. name .. "|r.")
		end
	end
	print(HEADER .. "Settings Saved.")
end

-- FRAMES STUFF
----========================----
--[[ Creates the Main Frame ]]--
----========================----
function CreateTheMainFrame(name)
	local f = CreateFrame("Frame", name, UIParent)
	f:SetMovable(true)
	f:EnableMouse(true)
	f:RegisterForDrag("LeftButton")
	f:SetScript("OnEvent", eventHandler)
	f:SetScript("OnDragStart", f.StartMoving)
	f:SetScript("OnDragStop", f.StopMovingOrSizing)
	local numRanksHeightMod = 175+((GuildControlGetNumRanks()-1)*25)
	if numRanksHeightMod < 350 then
		numRanksHeightMod = 350
	end
	f:SetSize(450, numRanksHeightMod)
	f:SetFrameStrata("MEDIUM")
	f:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
								edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
								tile = true,
								tileSize = 4,
								edgeSize = 16,
								insets = { 10, 10, 10, 10}})
	f:SetBackdropColor(0.1,0.1,0.1,0.9)
	f:SetBackdropBorderColor(1,1,1,0.5)
	f:SetPoint("CENTER", 0, 0)
		
	local TitleFont = f:CreateFontString(nil,"OVERLAY","GameFontHighlightLarge")
	TitleFont:SetText("Swyn's Guild Promoter v" .. version)
	TitleFont:SetPoint("TOP", f, "TOP", 0, -20)
		
	local FooterFont = f:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	FooterFont:SetText("-- Swyn")
	FooterFont:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -20, 20)
	f:Hide()
	
	local PromoteTypeFont = f:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	PromoteTypeFont:SetText("Promote/Demote Type:")
	PromoteTypeFont:SetPoint("TOPLEFT", f, "TOP", 20-(450/2), -100)
	local promoteTypes = {"Total GuildXP", "Level", "Achievement Points"}
	CreateDropDownMenu("PromoteType", f, -130, -115, promoteTypes)
	
	local desc = f:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	desc:SetText("Choose which ranks can be promoted or demoted and their limits.\nThen click Find, followed by the action you wish to take.\nPeople on Special ranks can't be demoted, but can be promoted.")
	desc:SetPoint("TOP", f, "TOP", 0, -50)

	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	FramesStuff["FRAMES"][name] = f
end

----========================----
--[[ Creates the List Frame ]]--
----========================----
function CreateTheListFrame(name, parent)
	local padding = 20
	local spacer = 10
	local textHeight = 10

	local f = CreateFrame("Frame", name, parent)
	
	local numRanksHeightMod = 175+((GuildControlGetNumRanks()-1)*25)
	if numRanksHeightMod < 350 then
		numRanksHeightMod = 350
	end
	f:SetSize(200, numRanksHeightMod)
	f:SetFrameStrata("MEDIUM")
	f:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
								edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
								tile = true,
								tileSize = 4,
								edgeSize = 16,
								insets = { 10, 10, 10, 10}})
	f:SetBackdropColor(0.1,0.1,0.1,0.9)
	f:SetBackdropBorderColor(1,1,1,0.5)
	f:SetPoint("TOPLEFT", parent, "TOPLEFT", -200, 0)
	f:Hide()

	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	-- Add scrolling message frames
	local SMFHeight = (numRanksHeightMod-(padding*2)-spacer-(textHeight*2))/2
	CreateScrollingMessageFrame("SwynGuildPromote_ScrollingMessageFrame_Promote", f, 170, SMFHeight, 0, -padding-textHeight)
	CreateScrollingMessageFrame("SwynGuildPromote_ScrollingMessageFrame_Demote", f, 170, SMFHeight, 0, -padding-(textHeight*2)-spacer-SMFHeight)
		
	-- Add Title Texts
	local PromoteFont = f:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	PromoteFont:SetText("Promotes")
	PromoteFont:SetPoint("CENTER", f, "TOP", 0, -padding)
	
	local DemoteFont = f:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	DemoteFont:SetText("Demotes")
	DemoteFont:SetPoint("CENTER", f, "TOP", 0, -padding-textHeight-SMFHeight-spacer)
	
	FramesStuff["LISTFRAME"][name] = f
end

----==========================----
--[[ Creates the Filter Frame ]]--
----==========================----
function CreateTheFilterFrame(name, parent)
	local padding = 20
	local spacer = 10
	local textHeight = 10

	local f = CreateFrame("Frame", name, parent)
	
	local numRanksHeightMod = 175+((GuildControlGetNumRanks()-1)*25)
	if numRanksHeightMod < 350 then
		numRanksHeightMod = 350
	end
	f:SetSize(200, numRanksHeightMod)
	f:SetFrameStrata("MEDIUM")
	f:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
								edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", 
								tile = true,
								tileSize = 4,
								edgeSize = 16,
								insets = { 10, 10, 10, 10}})
	f:SetBackdropColor(0.1,0.1,0.1,0.9)
	f:SetBackdropBorderColor(1,1,1,0.5)
	f:SetPoint("TOPLEFT", parent, "TOPRIGHT", 0, 0)
	f:Hide()

	local close = CreateFrame("Button",nil,f,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",f,"TOPRIGHT",-4,-4)
	
	-- Add scrolling message frames
	local SMFHeight = (numRanksHeightMod-(padding*2)-(spacer*2)-(textHeight*2)-30)/2
	CreateScrollingMessageFrame("SwynGuildPromote_ScrollingMessageFrame_ALT", f, 170, SMFHeight, 0, -padding-textHeight)
	CreateScrollingMessageFrame("SwynGuildPromote_ScrollingMessageFrame_DNP", f, 170, SMFHeight, 0, -padding-(textHeight*2)-spacer-SMFHeight)
		
	-- Add Title Texts
	local ALTFont = f:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	ALTFont:SetText("List of ALTs")
	ALTFont:SetPoint("CENTER", f, "TOP", 0, -padding)
	
	local DNPFont = f:CreateFontString(nil,"OVERLAY","GameFontHighlightSmall")
	DNPFont:SetText("List of DNPs")
	DNPFont:SetPoint("CENTER", f, "TOP", 0, -padding-textHeight-SMFHeight-spacer)
	
	-- Filter Toggle Buttons
	CreateButton("SwynGuildPromote_Button_Toggle_ALT", f, 80, 30, " ", -45, -numRanksHeightMod+padding+30)
	CreateButton("SwynGuildPromote_Button_Toggle_DNP", f, 80, 30, " ", 45, -numRanksHeightMod+padding+30)
	local alttext = "Off"
	local dnptext = "Off"
	if SwynGuildPromoterConfig.altfilter then
		alttext = "On"
	end
	if SwynGuildPromoterConfig.dnpfilter then
		dnptext = "On"
	end
	ModifyButton("SwynGuildPromote_Button_Toggle_ALT", "ALT: |cffEFE327" .. alttext .. "|r")
	ModifyButton("SwynGuildPromote_Button_Toggle_DNP", "DNP: |cffEFE327" .. dnptext .. "|r")
	
	FramesStuff["FILTERFRAME"][name] = f
end

----=================----
--[[ Creates Buttons ]]--
----=================----
function CreateButton(name, parent, width, height, text, offsetX, offsetY)
	local b = CreateFrame("Button", name, parent, "UIPanelButtonTemplate")
	b:SetWidth(width)
	b:SetHeight(height)
	b:SetPoint("TOP", parent, "TOP", offsetX, offsetY)
	
	--[[Button Scripts]]--
	-- Save Settings
	if name == "SwynGuildPromote_Button_Save" then
		b:SetScript("OnClick", SaveSettings)
	end
	-- Find --
	if name == "SwynGuildPromote_Button_Find" then
		b:SetScript("OnClick", Find)
	end
	-- Promote and Demote
	if name == "SwynGuildPromote_Button_DoBoth" then
		b:SetScript("OnClick", function()
						PromoteMembers()
						DemoteMembers()
					end)
	end
	-- Promote
	if name == "SwynGuildPromote_Button_OnlyPromote" then
		b:SetScript("OnClick", PromoteMembers)
	end
	-- Demote
	if name == "SwynGuildPromote_Button_OnlyDemote" then
		b:SetScript("OnClick", DemoteMembers)
	end
	-- Filters
	if name == "SwynGuildPromote_Button_Filter" then
		b:SetScript("OnClick", ShowFilters)
	end
	-- ALT Filter
	if name == "SwynGuildPromote_Button_Toggle_ALT" then
		b:SetScript("OnClick", function()
					SwynGuildPromoterConfig.altfilter = not SwynGuildPromoterConfig.altfilter
					local alttext = "Off"
					if SwynGuildPromoterConfig.altfilter then
						alttext = "On"
					end
					ModifyButton("SwynGuildPromote_Button_Toggle_ALT", "ALT: |cffEFE327" .. alttext .. "|r")
					ShowFilters()
				end)
	end
	-- DNP Filter
	if name == "SwynGuildPromote_Button_Toggle_DNP" then
		b:SetScript("OnClick", function()
					SwynGuildPromoterConfig.dnpfilter = not SwynGuildPromoterConfig.dnpfilter
					local dnptext = "Off"
					if SwynGuildPromoterConfig.dnpfilter then
						dnptext = "On"
					end
					ModifyButton("SwynGuildPromote_Button_Toggle_DNP", "DNP: |cffEFE327" .. dnptext .. "|r")
					ShowFilters()
				end)
	end
	
	local font = b:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	font:SetText(text)
	font:SetPoint("CENTER") --, parent, "CENTER", offsetX, offsetY)
	FramesStuff["FRAMES"][name] = b
	FramesStuff["BUTTONTEXTS"][name] = font
end

----================----
--[[ Edits Buttons ]]--
----================----
function ModifyButton(name, text)
	FramesStuff["BUTTONTEXTS"][name]:SetText(text)
end

----=====================----
--[[ Creates Check Boxes ]]--
----=====================----
function CreateCheckbox(name, parent, text, offsetX, offsetY, mode)
	local cb = CreateFrame("CheckButton", name, parent, "OptionsBaseCheckButtonTemplate")
	cb:SetPoint("TOP", parent, "TOP", offsetX, offsetY)
	
	local font = cb:CreateFontString("CheckFont"..name, "OVERLAY", "GameFontHighlight")
	font:SetText(text)
	font:SetPoint("LEFT", cb, "RIGHT", 4, 1)
	
	FramesStuff[mode][name] = cb
end

----=============================================----
--[[ Creates the checkboxes based on guild ranks ]]--
----=============================================----
function CreateRankCheckboxes(parent)
	-- Title
	local title = parent:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	title:SetText("Ranks")
	title:SetPoint("TOP", parent, "TOP", 6, -95)
	-- First work out how many guild ranks there are.
	GuildRoster()
	local numRanks = GuildControlGetNumRanks()
	local offsetX = -30
	local offsetY = -115
	
	for i=2,numRanks do
		local rankName = GuildControlGetRankName(i)
		CreateCheckbox(rankName, parent, rankName, offsetX, offsetY-(25*(i-2)), "CHECKBOXES")
		if SwynGuildPromoterConfig.selectedRanks[rankName] and SwynGuildPromoterConfig.selectedRanks[rankName][3] >= 0 then
			FramesStuff["CHECKBOXES"][rankName]:SetChecked(true)
		end
	end
end

----===============================================----
--[[ Creates the checkboxes based on special ranks ]]--
----===============================================----
function CreateSpecialCheckboxes(parent)
	-- Title
	local title = parent:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	title:SetText("Special")
	title:SetPoint("TOP", parent, "TOP", 184, -95)
	-- First work out how many guild ranks there are.
	GuildRoster()
	local numRanks = GuildControlGetNumRanks()
	local offsetX = 175
	local offsetY = -115
	
	for i=2,numRanks do
		local rankName = GuildControlGetRankName(i)
		CreateCheckbox(rankName, parent, "", offsetX, offsetY-(25*(i-2)), "SPECIALS")
		if SwynGuildPromoterConfig.specialRanks[rankName] then
			FramesStuff["SPECIALS"][rankName]:SetChecked(true)
		end
		if i==numRanks then
			FramesStuff["SPECIALS"][rankName]:SetChecked(false)
			FramesStuff["SPECIALS"][rankName]:Hide()
		end
	end
end

----==================----
--[[ Creats editboxes ]]--
----==================----
function CreateEditbox(name, parent, width, height, offsetX, offsetY)
	local eb = CreateFrame("EditBox", name, parent, "InputBoxTemplate")
	eb:SetPoint("TOP", parent, "TOP", offsetX, offsetY)
	eb:SetMaxLetters(8)
	eb:SetWidth(width)
	eb:SetHeight(height)
	eb:SetAutoFocus(false)
	eb:SetScript("OnEnterPressed", function(self) eb:ClearFocus() end)
	
	FramesStuff["EDITBOXES"][name] = eb
end

----=============================================----
--[[ Creates the editboxes to be used for limits ]]--
----=============================================----
function CreateRankEditboxes(parent)
	-- Title
	local title = parent:CreateFontString(nil,"OVERLAY","GameFontHighlight")
	title:SetText("Minimum")
	title:SetPoint("TOP", parent, "TOP", 112, -95)
	-- First work out how many guild ranks there are.
	GuildRoster()
	local numRanks = GuildControlGetNumRanks()
	local offsetX = 115
	local offsetY = -115
	
	for i=2,numRanks do
		local rankName = GuildControlGetRankName(i)
		CreateEditbox(rankName, parent, 60, 25, offsetX, offsetY-(25*(i-2)))
		if SwynGuildPromoterConfig.selectedRanks[rankName] and SwynGuildPromoterConfig.selectedRanks[rankName][3] >= 0 then
			FramesStuff["EDITBOXES"][rankName]:SetText(SwynGuildPromoterConfig.selectedRanks[rankName][3])
		else
			FramesStuff["EDITBOXES"][rankName]:SetText("")
		end
		if i == numRanks then
			FramesStuff["EDITBOXES"][rankName]:SetText(0)
			FramesStuff["EDITBOXES"][rankName]:Hide()
		end
	end
end

----================================----
--[[ Creats Scrolling Message Frame ]]--
----================================----
function CreateScrollingMessageFrame(name, parent, width, height, topOffsetX, topOffsetY)
	local smf = CreateFrame("ScrollingMessageFrame", name, parent)
	smf:SetPoint("TOP", parent, "TOP", topOffsetX, topOffsetY-3)
	smf:SetWidth(width-6)
	smf:SetHeight(height-6)
	smf:SetMaxLines(1000)
	smf:SetFading(false)
	smf:SetJustifyH("LEFT")
	smf:SetFontObject("GameFontHighlightSmall")
	smf:SetScript("OnMouseWheel", function(self, delta)
		if delta == 1 then
			if IsShiftKeyDown() then
				smf:ScrollToTop()
			else
				smf:ScrollUp()
			end
		else
			if IsShiftKeyDown() then
				smf:ScrollToBottom()
			else
				smf:ScrollDown()
			end
		end
		end)
		
	
	smf:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
								tile = true,
								tileSize = 2})
	smf:SetBackdropColor(0.0,0.0,0.0,0.8)
		
	FramesStuff["MESSAGEFRAMES"][name] = smf
end

----========================----
--[[ Create DropDown Menu's ]]--
----========================----
function CreateDropDownMenu(name, parent, offsetX, offsetY, items)
	local ddm = CreateFrame("Button", name, parent, "UIDropDownMenuTemplate")

	ddm:ClearAllPoints()
	ddm:SetPoint("TOP", parent, "TOP", offsetX, offsetY)
	ddm:Show()
	
	local function OnClick(self)
		UIDropDownMenu_SetSelectedID(ddm, self:GetID())
		DDMSelected[name] = self:GetID()
	end
	local function initialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		for k,v in pairs(items) do
			info = UIDropDownMenu_CreateInfo()
			info.text = v
			info.value = v
			info.func = OnClick
			UIDropDownMenu_AddButton(info, level)
		end
	end

	UIDropDownMenu_Initialize(ddm, initialize)
	UIDropDownMenu_SetWidth(ddm, 136);
	UIDropDownMenu_SetButtonWidth(ddm, 160)
	UIDropDownMenu_SetSelectedID(ddm, SwynGuildPromoterConfig.promoteType or 1)
	UIDropDownMenu_JustifyText(ddm, "LEFT")
	
	DDMSelected[name] = SwynGuildPromoterConfig.promoteType or 1
	FramesStuff["DROPDOWNS"][name] = ddm
end

----==============================----
--[[ Actually Generate the Frames ]]--
----==============================----
local SGP_FRAME = CreateFrame("Frame")
SGP_FRAME:RegisterEvent("PLAYER_LOGIN")
SGP_FRAME:SetScript("OnEvent",OnLogin)

function loadEverything()
	-- Main Frame Stuff
	local FindButtonHeight = -160
	CreateTheMainFrame("SwynGuildPromote_Frame")
	CreateButton("SwynGuildPromote_Button_Find", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"], 160, 30, "Find", -130, FindButtonHeight)
	CreateButton("SwynGuildPromote_Button_DoBoth", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"], 160, 30, "Promote and Demote", -130, FindButtonHeight-50)
	CreateButton("SwynGuildPromote_Button_OnlyPromote", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"], 160, 30, " ", -130, FindButtonHeight-90)
	CreateButton("SwynGuildPromote_Button_OnlyDemote", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"], 160, 30, " ", -130, FindButtonHeight-130)
	ModifyButton("SwynGuildPromote_Button_OnlyPromote", "Only Promote: 0")
	ModifyButton("SwynGuildPromote_Button_OnlyDemote", "Only Demote: 0")
	CreateRankCheckboxes(FramesStuff["FRAMES"]["SwynGuildPromote_Frame"])
	CreateRankEditboxes(FramesStuff["FRAMES"]["SwynGuildPromote_Frame"])
	CreateSpecialCheckboxes(FramesStuff["FRAMES"]["SwynGuildPromote_Frame"])
	local SaveButtonYOffset = -115-((GuildControlGetNumRanks()-1)*25)-5
	CreateButton("SwynGuildPromote_Button_Save", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"], 100, 30, "Save Settings", 25, SaveButtonYOffset)
	CreateButton("SwynGuildPromote_Button_Filter", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"], 80, 30, "Filters", 165, SaveButtonYOffset+15)
	
	-- List Frame Stuff
	CreateTheListFrame("SwynGuildPromote_ListFrame", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"])
	-- Filter Frame Stuff
	CreateTheFilterFrame("SwynGuildPromote_FilterFrame", FramesStuff["FRAMES"]["SwynGuildPromote_Frame"])
end